<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="editFormCarConnectMenuRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="14">
            <el-form-item label="选择上级菜单" prop="TourCarContractMenu.parentId">
              <el-cascader
                class="input-item"
                v-model="parentIdPath"
                :options="parentIdWidgetDropdownList"
                placeholder=""
                :clearable="true"
                :filterable="true"
                :show-all-levels="false"
                :props="{ value: 'id', label: 'name', children: 'children', checkStrictly: true }"
                @change="onParentIdValueChange"
              />
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="菜单名称" prop="TourCarContractMenu.menuName">
              <el-input
                class="input-item"
                v-model="formData.TourCarContractMenu.menuName"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="14">
            <el-form-item label="显示顺序" prop="TourCarContractMenu.showOrder">
              <el-input-number
                class="input-item"
                v-model="formData.TourCarContractMenu.showOrder"
                placeholder=""
                :clearable="true"
                :step="1"
                :controls="true"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="是否启用" prop="TourCarContractMenu.enable">
              <el-radio-group
                class="input-item"
                v-model="formData.TourCarContractMenu.enable"
              >
                <el-radio
                  v-for="item in enableWidgetDropdownList"
                  :key="item.id"
                  :label="item.id"
                >
                  {{ item.name }}
                </el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onUpdateClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'editFormCarConnectMenu',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourCarContractMenuData } from '@/api/generated/tourCarContractMenuController';
import { TourCarContractMenuController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const editFormCarConnectMenuRef = ref();
// 表单数据定义
type EditFormCarConnectMenuData = {
  TourCarContractMenu: TourCarContractMenuData;
};
// 表单数据
const formData = reactive<EditFormCarConnectMenuData>({
  TourCarContractMenu: {
    // 主键id
    id: undefined,
    // 父级id
    parentId: undefined,
    // 菜单名称
    menuName: undefined,
    // 显示顺序
    showOrder: undefined,
    // 是否启用，0禁用，1启用
    enable: undefined,
    // 创建用户
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新用户
    updateUserId: undefined,
    // 更新时间
    updateTime: undefined,
    // 删除标记(1: 正常 -1: 已删除)
    dataState: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourCarContractMenu.showOrder': [
    {required: true, message: '请输入显示顺序', trigger: 'blur'}
  ],
  'TourCarContractMenu.menuName': [
    {required: true, message: '请输入菜单名称', trigger: 'blur'}
  ],
  'TourCarContractMenu.enable': [
    {required: true, message: '请输入是否启用', trigger: 'blur'}
  ],
  'TourCarContractMenu.parentId': [
    // {required: true, message: '请输入选择上级菜单', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourCarContractMenuData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourCarContractMenu = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourCarContractMenuController.view(params).then(res => {
      formData.TourCarContractMenu = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 选择上级菜单下拉数据获取函数
 */
const loadParentIdDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    const params = {
    };
    DictionaryController.dictTourCarContractMenu(params).then(res => {
      resolve({
        dataList: res.getList(),
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 选择上级菜单选中值改变
 */
const onParentIdValueChange = (value) => {
  formData.TourCarContractMenu.parentId = Array.isArray(value) ? value[value.length - 1] : value;
};
// 选择上级菜单配置参数
const parentIdOptions: DropdownOptions<DictData> = {
  loadData: loadParentIdDropdownList,
  isTree: true,
};
// 选择上级菜单选中数据
const parentIdPath = ref<Array<string | number>>([]);
// 选择上级菜单下拉组件
const parentIdWidget = useDropdown(parentIdOptions);
const { dropdownList: parentIdWidgetDropdownList } = parentIdWidget
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableOptions: DropdownOptions<DictData> = {
  loadData: loadEnableDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableWidget = useDropdown(enableOptions);
const { dropdownList: enableWidgetDropdownList } = enableWidget
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshEditFormCarConnectMenu = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetEditFormCarConnectMenu = () => {
  refreshEditFormCarConnectMenu();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetEditFormCarConnectMenu();
};
/**
 * 保存
 */
const onUpdateClick = () => {
  editFormCarConnectMenuRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.TourCarContractMenu
      };
    retFormData.parentIdDictMap = findTreeNode(parentIdWidgetDropdownList.value, retFormData.parentId, 'id');
    retFormData.enableDictMap = findItemFromList(enableWidgetDropdownList.value, retFormData.enable, 'id');
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      tourCarContractMenuDto: {
        id: formData.TourCarContractMenu.id,
        menuName: formData.TourCarContractMenu.menuName,
        parentId: formData.TourCarContractMenu.parentId,
        showOrder: formData.TourCarContractMenu.showOrder,
        enable: formData.TourCarContractMenu.enable,
        createUserId: formData.TourCarContractMenu.createUserId,
        createTime: formData.TourCarContractMenu.createTime,
        updateUserId: formData.TourCarContractMenu.updateUserId,
        updateTime: formData.TourCarContractMenu.updateTime,
      }
    };

    let httpCall = isEdit.value ? TourCarContractMenuController.update : TourCarContractMenuController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourCarContractMenuData().then(res => {
    parentIdWidget.onVisibleChange(true).then(res => {
      // TODO: 获取级联选中路径
      parentIdPath.value = findTreeNodePath(res, formData.TourCarContractMenu.parentId);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
    enableWidget.onVisibleChange(true).catch(e => {console.error(e)});
    if (isEdit.value) refreshEditFormCarConnectMenu();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
